import sys
from PyQt5.QtWidgets import QApplication,QWidget,QPlainTextEdit
from PyQt5.QtWidgets import QScrollArea,QVBoxLayout, QAbstractItemView, QListWidget,QListWidgetItem, QPushButton, QFileDialog,QDialog
from PyQt5.QtCore import pyqtSlot
from PyQt5 import uic,QtGui
import pandas as pd
import numpy as np
import matplotlib.pyplot as plt

from matplotlib.backends.backend_qt5agg import FigureCanvas, NavigationToolbar2QT as NavigationToolbar
from matplotlib.figure import Figure


uifile_1 = "plot_builder.ui" # Enter file here.

form_1, base_1 = uic.loadUiType(uifile_1)

class Example(base_1, form_1):
    def __init__(self):
        super().__init__()
        self.setupUi(self)
        self.layout = QVBoxLayout(self)
        
        ######
        # a figure instance to plot on
        self.figure = plt.figure()

        # this is the Canvas Widget that displays the `figure`
        # it takes the `figure` instance as a parameter to __init__
        self.canvas = FigureCanvas(self.figure)

        # set the layout
        layout = QVBoxLayout()
        #layout.addWidget(self.toolbar)
        #layout.addWidget(self.canvas)
        self.scrollArea.setWidget(self.canvas)
        self.setLayout(layout)
        
        #####
        
        
        self.fileOpen.clicked.connect(self.file_open_dialogue)
        self.buildBut.clicked.connect(self.build_plot)
        self.df=pd.DataFrame() #global dataframe

    def file_open_dialogue(self):
        
        fileName = QFileDialog.getOpenFileName(self,"Data files (*.csv)")
        
        #self.label.setText("Hello "+self.lineEdit.text())
        if fileName:
            print(fileName[0])
            self.filePath.setPlainText(fileName[0])
            self.df=pd.read_csv(fileName[0],sep=';')
            labels=self.df.columns
            for i in labels:
                item1 = QListWidgetItem() #need to copy theese items twice
                item1.setText(str(i))
                self.list1.addItem(item1)
            self.list1.setSelectionMode(QAbstractItemView.MultiSelection)
            self.list1.itemSelectionChanged.connect(self.on_change1)
            print(self.df)
            
        
    def build_plot(self):
        item_list=[item.text() for item in self.list1.selectedItems()]
        print(item_list)
        
        print('my_frame',self.df,'\n\n\n\n\n')
        #print(self.df(str(item_list[0])))
        idx1=item_list[0];idx2=item_list[1]
        x=self.df[idx1]
        y=self.df[idx2]
        #self._static_ax.plot(x,y)
        plt.plot(x,y)
        plt.show()
        ###
        self.figure.clear()

        # create an axis
        ax = self.figure.add_subplot(111)

        # discards the old graph
        # ax.hold(False) # deprecated, see above

        # plot data
        ax.plot(x,y, '*-')

        # refresh canvas
        self.canvas.draw()
        ###
        
    def on_change1(self):
        print("start")
        print([item.text() for item in self.list1.selectedItems()])
        
    
            
if __name__ == '__main__':
    app = QApplication(sys.argv)
    ex = Example()
    ex.show()
    sys.exit(app.exec_())